;"This line left intentionally nonsense" - frisst der Assembler im List-File ;)
; ****************************************************************************
; *                              Projekt W006S003                            *
; *                     Firmware fr Geocaching-Magnetbake                   *
; *                             auf Atmel AVR-Basis                          *
; ****************************************************************************
; *                                                                          *
; *                (c) 2009-2019 Jochen Wienstroth                           *
; *                wienstroth Elektronikentwicklung                          *
; *                Am Deutschherrenberg 33                                   *
; *                D-35578 Wetzlar                                           *
; *                Tel: auf Anfrage / Fax: 06441-445062                      *
; *                http://www.hw-entwickler.de                               *
; *                mailto: jw@hw-entwickler.de                               *
; *                                                                          *
; *                                                     2019-01-10           *
; *                                                                          *
; ****************************************************************************
; *                                                                          *
; *                Die Nutzung dieser Software ist nur erlaubt im            *
; *                Rahmen der Lizenz Creative Commons CC-BY-NC-SA            *
; *                V3.0 - siehe auch                                         *
; *                                                                          *
; *               http://creativecommons.org/licenses/by-nc-sa/3.0/          *
; *                                                                          *
; *                Jede Abweichung der Nutzung dieser Software               *
; *                von den genannten Bestimmungen darf nur                   *
; *                mit schriftlicher Genehmigung durch den oben              *
; *                genannten Urheberrechtsinhaber erfolgen !                 *
; *                                                                          *
; ****************************************************************************

CRBEG:

; +--------------------------------------------------------------------------+
; |          Vordefinierte Segmente fr Ausgabe auf 7Segment-Anzeige         |
; +--------------------------------------------------------------------------+
.equ SEG_a   = 0x01;   oben quer          -------
.equ SEG_b   = 0x02;   oben rechts       |   a   |
.equ SEG_c   = 0x04;   unten rechts      |f     b|
.equ SEG_d   = 0x08;   unten quer        |       |
.equ SEG_e   = 0x10;   unten links        -------
.equ SEG_f   = 0x20;   oben links        |   g   |
.equ SEG_g   = 0x40;   mitte quer        |e     c|
.equ SEG_DP  = 0x80;   Dezimalpunkt      |   d   |
;                                         -------  O DP

; +--------------------------------------------------------------------------+
; |         Vordefinierte Zeichen zur Ausgabe auf 7Segment-Anzeige           |
; +--------------------------------------------------------------------------+

.equ SYM_A = SEG_a | SEG_b | SEG_c | SEG_e | SEG_f | SEG_g ; "A"                
;  --------
; |        |
; |        |
; |        |
;  --------
; |        |
; |        |
; |        |
;

.equ SYM_kl_b = SEG_c | SEG_d | SEG_e | SEG_f | SEG_g ; "b"
;
; |
; |
; |
;  --------
; |        |
; |        |
; |        |
;  --------

.equ SYM_kl_c = SEG_d | SEG_e | SEG_g ; "c"
;
;
;
;
;  --------
; |
; |
; |
;  --------

.equ SYM_C = SEG_a | SEG_d | SEG_e | SEG_f ; "C"
;  --------
; |
; |
; |
;
; |
; |
; |
;  --------

.equ SYM_kl_d = SEG_b | SEG_c | SEG_d | SEG_e | SEG_g ; "d"
;
;          |
;          |
;          |
;  --------
; |        |
; |        |
; |        |
;  --------

.equ SYM_E = SEG_a | SEG_d | SEG_e | SEG_f | SEG_g ; "E"
;  --------
; |
; |
; |
;  --------
; |
; |
; |
;  --------

.equ SYM_F = SEG_a | SEG_e | SEG_f | SEG_g ; "F"
;  --------
; |
; |
; |
;  --------
; |
; |
; |
;

.equ SYM_G = SEG_a | SEG_c | SEG_d | SEG_e | SEG_f | SEG_g ; "G"
;  --------
; |
; |
; |
;  --------
; |        |
; |        |
; |        |
;  --------

.equ SYM_kl_h = SEG_c | SEG_e | SEG_f | SEG_g ; "h"
;
; |
; |
; |
;  --------
; |        |
; |        |
; |        |
;

.equ SYM_H = SEG_b | SEG_c | SEG_e | SEG_f | SEG_g ; "H"
; 
; |        |
; |        |
; |        |
;  --------
; |        |
; |        |
; |        |
;

.equ SYM_I = SEG_e | SEG_f ; "I"
;
; |
; |
; |
;
; |
; |
; |
;

.equ SYM_J = SEG_b | SEG_c | SEG_d | SEG_e ; "J"
;
;          |
;          |
;          |
;
; |        |
; |        |
; |        |
;  --------

.equ SYM_kl_l = SEG_d | SEG_e ; "l"
;  
;
;
;
;
; |
; |
; |
;  --------

.equ SYM_L = SEG_d | SEG_e | SEG_f ; "L"
;
; |
; |
; |
; 
; |
; |
; |
;  --------

.equ SYM_kl_n = SEG_c | SEG_e | SEG_g ; "n"
;
;
;
;
;  --------
; |        |
; |        |
; |        |
;

.equ SYM_N = SEG_a | SEG_b | SEG_c | SEG_e | SEG_f ; "N"
;  --------
; |        |
; |        |
; |        |
;
; |        |
; |        |
; |        |
;

.equ SYM_O = SEG_a | SEG_b | SEG_c | SEG_d | SEG_e | SEG_f ; "O"
;  --------
; |        |
; |        |
; |        |
;
; |        |
; |        |
; |        |
;  --------

.equ SYM_kl_o = SEG_c | SEG_d | SEG_e | SEG_g ; "o"
;
;
;
;
;  --------
; |        |
; |        |
; |        |
;  --------

.equ SYM_P = SEG_a | SEG_b | SEG_e | SEG_f | SEG_g ; "P"
;  --------
; |        |
; |        |
; |        |
;  --------
; |
; |
; |
;

.equ SYM_kl_r = SEG_e | SEG_g ; "r"
;
;
;
;
;  --------
; |
; |
; |
;

.equ SYM_S = SEG_a | SEG_c | SEG_d | SEG_f | SEG_g ; "S"
;  --------
; |
; |
; |
;  --------
;          |
;          |
;          |
;  --------

.equ SYM_kl_t = SEG_d | SEG_e | SEG_f | SEG_g ; "t"
; 
; |
; |
; |
;  --------
; |
; |
; |
;  --------

.equ SYM_kl_u = SEG_c | SEG_d | SEG_e ; "u"
;
;
;
;
;
; |        |
; |        |
; |        |
;  --------

.equ SYM_U = SEG_b | SEG_c | SEG_d | SEG_e | SEG_f ; "U"
;
; |        |
; |        |
; |        |
;
; |        |
; |        |
; |        |
;  --------

.equ SYM_Y = SEG_b | SEG_c | SEG_d | SEG_f | SEG_g ; "Y"
;  
; |        |
; |        |
; |        |
;  --------
;          |
;          |
;          |
;  --------

.equ SYM_Z = SEG_a | SEG_b | SEG_d | SEG_e | SEG_g ; "Z", identisch zu "2"
;  --------
;          |
;          |
;          |
;  --------
; |
; |
; |
;  --------

.equ SYM_gleich = SEG_d | SEG_g ; "=" unten
;
;
;
;
;  --------
;
; 
;
;  --------

.equ SYM_gl_ob = SEG_a | SEG_g ; "=" oben
;  --------
;
;
;
;  --------
;
;
;
;

.equ SYM_minus = SEG_g ; "-"
;
;
;
;
;  --------
;
;
;
;

.equ SYM_leer   = 0x00 	; " "
;
;
;
;
;
;
;
;
;

.equ SYM_punkt  = SEG_DP 	; "."
;
;
;
;
;
;
;
;
;             *

.equ SYM_Anf = SEG_b | SEG_f ; " Anfhrungszeichen "
; 
; |        |
; |        |
; |        |
;              
; 
; 
; 
; 

.equ SYM_SLA = SEG_b | SEG_e | SEG_g ; "/"
; 
;          |
;          |
;          |
;  --------
; | 
; |
; |
;  

.equ SYM_BSL = SEG_c | SEG_f | SEG_g ; "\"
;  
; |
; |
; |
;  --------
;          |
;          |
;          |
;

.equ SYM_KLA = SEG_a | SEG_d | SEG_e | SEG_f ; "["
;  --------
; |
; |
; |
;
; |
; |
; |
;  --------

.equ SYM_KLZ = SEG_a | SEG_b | SEG_c | SEG_d ; "]"
;  --------
;          |
;          |
;          |
;
;          |
;          |
;          |
;  --------

.equ SYM_DEG = SEG_a | SEG_b | SEG_f | SEG_g ; ""
;  --------
; |        |
; |        |
; |        |
;  --------
; 
;
;
;


.equ SYM_0 = SEG_a | SEG_b | SEG_c | SEG_d | SEG_e | SEG_f ; "0"
;  --------
; |        |
; |        |
; |        |
;
; |        |
; |        |
; |        |
;  --------

.equ SYM_1 = SEG_b | SEG_c ; "1"
;
;          |
;          |
;          |
;
;          |
;          |
;          |
;

.equ SYM_2 = SEG_a | SEG_b | SEG_d | SEG_e | SEG_g ; "2"
;  --------
;          |
;          |
;          |
;  --------
; |
; |
; |
;  --------

.equ SYM_3 = SEG_a | SEG_b | SEG_c | SEG_d | SEG_g ; "3"
;  --------
;          |
;          |
;          |
;  --------
;          |
;          |
;          |
;  --------

.equ SYM_4 = SEG_b | SEG_c | SEG_f | SEG_g ; "4"
;
; |        |
; |        |
; |        |
;  --------
;          |
;          |
;          |
;

.equ SYM_5 = SEG_a | SEG_c | SEG_d | SEG_f | SEG_g ; "5"
;  --------
; |
; |
; |
;  --------
;          |
;          |
;          |
;  --------

.equ SYM_6 = SEG_a | SEG_c | SEG_d | SEG_e | SEG_f | SEG_g ; "6"
;  --------
; |
; |
; |
;  --------
; |        |
; |        |
; |        |
;  --------

.equ SYM_7 = SEG_a | SEG_b | SEG_c | SEG_f; "7"
;  --------
; |        |
; |        |
; |        |
;
;          |
;          |
;          |
;

.equ SYM_8 = SEG_a | SEG_b | SEG_c | SEG_d | SEG_e | SEG_f | SEG_g ; "8"
;  --------
; |        |
; |        |
; |        |
;  --------
; |        |
; |        |
; |        |
;  --------

.equ SYM_9 = SEG_a | SEG_b | SEG_c | SEG_d | SEG_f | SEG_g ; "9"
;  --------
; |        |
; |        |
; |        |
;  --------
;          |
;          |
;          |
;  --------

; Hinweis: Weitere Zeichen, Buchstaben, Symbole knnen beliebig selbst
; ======== definiert werden als SYM_?? und an entsprechender Stelle in
;          der hierunter folgenden bersetzungstabelle eingetragen 
;          werden, um zur Benutzung zur Verfgung zu stehen.

; +--------------------------------------------------------------------------+
; |          Character-ROM zur bersetzung 7Bit-ASCII nach 7Segment          |
; +--------------------------------------------------------------------------+

; Hinweis: Der erste Eintrag ist ein Leerzeichen, damit Padding-Bytes bei
; ======== ungeraden Nachrichtenlngen als Leerzeichen ausgegeben werden,
;          die nchsten Zeichen (1 bis 8) sind die Segmente a bis g und
;          der Dezimalpunkt als Einzelsegmente, falls jemand hiermit
;          lustige pseudoanimierte Bildchen malen mchte.

CHRROM:		; Anfang Tabelle Character-ROM

#ifndef GENATDW	; Tabelle nur einbauen, wenn keine ATDW-Generierung gewnscht

; 0x00+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   
.db SYM_leer, SEG_a, SEG_b, SEG_c, SEG_d, SEG_e, SEG_f, SEG_g

; 0x00+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;
.db SEG_DP, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer

; 0x10+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
; 
.db SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer

; 0x10+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;
.db SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SYM_leer

; 0x20+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   Leer  !     "     #     $     %     &     '
.db SYM_leer, SYM_leer, SYM_Anf, SYM_leer, SYM_leer, SYM_leer, SYM_leer, SEG_b

; 0x20+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;   (     )     *     +     ,     -     .     /
.db SYM_KLA, SYM_KLZ, SYM_DEG, SYM_leer, SEG_DP, SYM_minus, SEG_DP, SYM_SLA

; 0x30+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   0     1     2     3     4     5     6     7
.db SYM_0, SYM_1, SYM_2, SYM_3, SYM_4, SYM_5, SYM_6, SYM_7

; 0x30+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;   8     9     :     ;     <     =     >     ?
.db SYM_8, SYM_9, SYM_leer, SYM_leer, SYM_leer, SYM_gleich, SYM_leer, SYM_leer

; 0x40+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   @     A     B     C     D     E     F     G
.db SYM_leer, SYM_A, SYM_kl_b, SYM_C, SYM_kl_d, SYM_E, SYM_F, SYM_G

; 0x40+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;   H     I     J     K     L     M     N     O
.db SYM_H, SYM_I, SYM_J, SYM_leer, SYM_L, SYM_leer, SYM_N, SYM_O

; 0x50+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   P     Q     R     S     T     U     V     W
.db SYM_P, SYM_leer, SYM_kl_r, SYM_S, SYM_kl_t, SYM_U, SYM_leer, SYM_leer

; 0x50+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;   X     Y     Z     [     \     ]     ^     _
.db SYM_leer, SYM_Y, SYM_Z, SYM_KLA, SYM_BSL, SYM_KLZ, SYM_leer, SEG_d

; 0x60+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   `     a     b     c     d     e     f     g
.db SEG_f, SYM_A, SYM_kl_b, SYM_kl_c, SYM_kl_d, SYM_E, SYM_F, SYM_G

; 0x60+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;   h     i     j     k     l     m     n     o
.db SYM_kl_h, SYM_I, SYM_J, SYM_leer, SYM_kl_l, SYM_leer, SYM_kl_n, SYM_kl_o

; 0x70+
;   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07
;   p     q     r     s     t     u     v     w
.db SYM_P, SYM_leer, SYM_kl_r, SYM_S, SYM_kl_t, SYM_kl_u, SYM_leer, SYM_leer

; 0x70+
;   0x08, 0x09, 0x0a, 0x0b, 0x0c, 0c0d, 0x0e, 0x0f
;   x     y     z     {     |     }     ~     DEL
.db SYM_leer, SYM_Y, SYM_Z, SYM_leer, SYM_I, SYM_leer, SYM_leer, SYM_leer

; Bit7 (MSB) unbenutzt, bitte vor Tabellenbenutzung ausmaskieren sonst gibt
; es wundersame Fehllandungen in anderen Flash-Bereichen ;)

#else			; wenn keine ATDW-Generierung gewnscht stattdessen nur
 .org ENDASM+64 ; Offset einfgen, damit Botschafts-Beginn wieder stimmt.
#endif			

; ****************************************************************************
; *                                                                          *
; * Rudimentre Plausibilittsprfung auf Wurstfingerfehler: Tabelle muss    *
; * exakt 64 Worte = 128 Eintrge = 128 Bytes lang sein, sonst ist irgendwas *
; * in der obenstehenden Tabellennotation schiefgegangen.                    *
; *                                                                          *
; ****************************************************************************

CREND:

.if (CREND-CRBEG)!=64
 .error"ABBRUCH: Character ROM falsche Gre, muss exakt 64 Worte (128 Eintrge) gro sein!"
.endif

; ****************************************************************************
; ****************************************************************************
; *                                                                          *
; *                E N D E   C H A R A C T E R - R O M                       *
; *                                                                          *
; ****************************************************************************
; ****************************************************************************
